"""SNAKES is the Net Algebra Kit for Editors and Simulators

@author: Franck Pommereau
@organization: University of Paris 12
@copyright: (C) 2005 Franck Pommereau
@license: GNU Lesser General Public Licence (aka. GNU LGPL),
    see the file C{doc/COPYING} in the distribution or visit U{the GNU
    web site<http://www.gnu.org/licenses/licenses.html#LGPL>}
@contact: pommereau@univ-paris12.fr

SNAKES is a Python library allowing to model all sorts of Petri nets
and to execute them. It is very general as most Petri nets annotations
can be arbitrary Python expressions while most values can be arbitrary
Python objects.

SNAKES can be further extended with plugins, several ones being
already provided, in particular two plugins implement the Petri nets
compositions defined for the Petri Box Calculus and its successors.
"""

class ConstraintError (Exception) :
    "Violation of a constraint"
    pass

class NodeError (Exception) :
    "Error related to a place or a transition"
    pass

class DomainError (Exception) :
    "Function applied out of its domain"
    pass

class ModeError (Exception) :
    "The modes of a transition cannot be found"
    pass

class PluginError (Exception) :
    "Error when adding a plugin"
    pass

class ParseError (Exception) :
    "Error while parsing a piece of text"
    pass

class UnificationError (Exception) :
    "Error while unifying parameters"
    pass
