        def _get_state (self, marking) :
            stripped = marking.copy(lash=False)
            self._subsets = []
            if stripped in self._marking2data :
                for num, data in self._marking2data[stripped].iteritems() :
                    if marking.lash == data :
                        return num
                    elif marking.lash.issubset(data) :
                        return num
                    elif data.issubset(marking.lash) :
                        self._subsets.append(num)
            self._create_state(marking)
            if stripped in self._marking2data :
                self._marking2data[stripped][self._last] = marking.lash
            else :
                self._marking2data[stripped] = {self._last: marking.lash}
            return self._last
        def _add_trans (self, trans, mode, source, target) :
            module.StateGraph._add_trans(self, trans, mode, source, target)
            if self._cycles :
                self._saturate_cycles(trans, mode, source, target)
            self._subsets = []
        def _saturate_cycles(self, trans, mode, source, target) :
            if len(self._subsets) == 0 :
                return
            # take the last added that is the largets
            loop = max(self._subsets)
            data = self._state2marking[target].lash
            # compute the iterated transformation
            t = self.net.lash.linear_transf(True, None)
            for c in self._paths(loop, self._last, set()) :
                print "# cycle", c
                x = c[0]
                for y in c[1:] :
                    trans, mode = self._succ[x][y]
                    t = t & self.net.lash._lt[trans]
                    x = y
            # saturate the data set
            data = t.star(data)
            # replace the new state
            marking = self._state2marking.pop(target)
            del self._marking2state[marking]
            stripped = marking.copy(lash=False)
            self._marking2data[stripped][target] = data
            marking.lash = data
            self._state2marking[target] = marking
            self._marking2state[marking]= target
            # remove the covered states
            if self._remove :
                for old in self._subsets :
                    # reconnect its predecessors to the new state
                    for pred in self._pred[old] :
                        self._succ[pred][target] = self._succ[pred][old]
                        del self._succ[pred][old]
                    self._remove_state(old)
        def _remove_state (self, number) :
            todo = [number]
            while len(todo) > 0 :
                num = todo.pop(0)
                if num not in self._state2marking :
                    continue
                print "# remove", num
                for succ in self._succ[num] :
                    del self._pred[succ][num]
                    if len(self._pred[succ]) == 0 :
                        todo.append(succ)
                    elif (len(self._pred[succ]) == 1
                          and succ in self._pred[succ]) :
                        todo.append(succ)
                del self._pred[num]
                del self._succ[num]
                marking = self._state2marking.pop(num)
                del self._marking2state[marking]
                del marking.lash
                del self._marking2data[marking][num]
        def _paths (self, source, target, visited) :
            for step in self._succ[source] :
                if step == source :
                    continue
                if step == target :
                    yield (source, target)
                if step not in visited :
                    for cycle in self._paths(step, target,
                                             visited | set([source])) :
                        yield (source,) + cycle
